/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : Delete price
*/

CREATE PROCEDURE [dbo].[SP_DLV_DELETE_PRICE]
@GRID VARCHAR(MAX),
@CHANGED_BY VARCHAR(50)
AS
BEGIN

--CHECK USER
DECLARE @CHECK_AUTH INT;
SET @CHECK_AUTH = (SELECT COUNT (*) FROM TB_R_VW_EMPLOYEE WHERE JOB_FUNCTION_ID = 11 AND USERNAME = @CHANGED_BY);
IF (@CHECK_AUTH=1)BEGIN

	--CREATE TABLE TEMPORARY
	CREATE TABLE #TEMP(
			ROUTE_CD VARCHAR(MAX),
			LP_CD VARCHAR(MAX),
			VALID_FROM VARCHAR(MAX),
			VALID_TO VARCHAR(MAX)
		);
		
	

		--==Temporary==--
		--  == VARIABLE TABLE TEMPORARY UNTUK EXPLODING GRID ==
		DECLARE @ROWS TABLE(ID INT,ITEM VARCHAR(MAX));
		DECLARE @MIN_ROW INT;
		DECLARE @ROW_DETAIL VARCHAR(MAX);
		DECLARE @FIELDS TABLE(ID INT,ITEM VARCHAR(MAX));
		DECLARE @MIN_FIELD INT;
		-- ================================================================
		--  == Variabel Untuk Menyimpan Data Ke TABLE DETAIL ==
		DECLARE @arr_1 VARCHAR(MAX),@arr_2 VARCHAR(MAX),@arr_3 VARCHAR(MAX),@arr_4 VARCHAR(MAX)
		DECLARE @YEAR_FROM VARCHAR (MAX),@MONTH_FROM VARCHAR(MAX),@DAY_FROM VARCHAR(MAX)
		DECLARE @YEAR_TO VARCHAR (MAX),@MONTH_TO VARCHAR(MAX),@DAY_TO VARCHAR(MAX)
		DECLARE @VALID_FROM VARCHAR(MAX),@VALID_TO VARCHAR(MAX)
			
		INSERT INTO @ROWS
		SELECT * FROM dbo.FN_DLV_ATD_EXPLODE(@GRID,';');
		-- ================================================================
		--  == Ambil Nilai terkecil dari VARIABEL TABLE @ROW ==
		SET @MIN_ROW = (SELECT MIN(ID) FROM @ROWS);

		WHILE @MIN_ROW IS NOT NULL BEGIN
					-- 6.3.1 == Hapus VARIABLE TABLE @FIELDS jika ada ==
					DELETE FROM @FIELDS;
					
					SET @ROW_DETAIL = (SELECT ITEM FROM @ROWS WHERE ID = @MIN_ROW);
					INSERT INTO @FIELDS
					SELECT * FROM dbo.FN_DLV_ATD_EXPLODE(@ROW_DETAIL,'_');
					-- ========================================================================================
					-- 6.3.3 == Ambil ITEM Berdasarkan ID untuk dimasukkan kedalam VARIABLE FIELD Detail ==
					SET @arr_1 = (SELECT ITEM FROM @FIELDS WHERE ID = 1);
					SET @arr_2 = (SELECT ITEM FROM @FIELDS WHERE ID = 2);
					SET @arr_3 = (SELECT ITEM FROM @FIELDS WHERE ID = 3);
					SET @arr_4 = (SELECT ITEM FROM @FIELDS WHERE ID = 4);
					
					--VALID FROM
					SET @YEAR_FROM = SUBSTRING(@arr_3,7,10);
					SET @MONTH_FROM = SUBSTRING(@arr_3,4,2);
					SET @DAY_FROM = SUBSTRING(@arr_3,1,2);
					SET @VALID_FROM = @YEAR_FROM + '-' + @MONTH_FROM + '-' + @DAY_FROM
					--VALID TO
					SET @YEAR_TO = SUBSTRING(@arr_4,7,10);
					SET @MONTH_TO = SUBSTRING(@arr_4,4,2);
					SET @DAY_TO = SUBSTRING(@arr_4,1,2);
					SET @VALID_TO = @YEAR_TO + '-' + @MONTH_TO + '-' + @DAY_TO
					
					INSERT INTO #TEMP VALUES (@arr_1,@arr_2,@VALID_FROM,@VALID_TO)

					SET @MIN_ROW = (SELECT TOP 1 ID FROM @ROWS WHERE ID > @MIN_ROW ORDER BY ID ASC);
									-- =================================================================================
		END --END WHILE
		--==Temporary==--
		--CHECK 
		DECLARE @CHECK_VALID INT,@CHECK_VALID2 INT
		SET @CHECK_VALID =(SELECT COUNT(*) FROM #TEMP WHERE VALID_TO ='9999-12-31');
		SET @CHECK_VALID2 =(SELECT COUNT(*) FROM #TEMP);
		
		IF(@CHECK_VALID = @CHECK_VALID2) BEGIN
		
				--LOOPING TABLE TEMP
				DECLARE @ROUTE_CD VARCHAR(50),@LP_CD VARCHAR(MAX),@VALID_FROM_CR VARCHAR(MAX),@VALID_TO_CR VARCHAR(MAX)
					
				DECLARE C_ROUTE CURSOR FOR
				SELECT ROUTE_CD,LP_CD,VALID_FROM,VALID_TO FROM #TEMP
				OPEN C_ROUTE
					
				FETCH NEXT FROM C_ROUTE INTO @ROUTE_CD,@LP_CD,@VALID_FROM_CR,@VALID_TO_CR
				WHILE @@FETCH_STATUS = 0
				BEGIN
				
					--CHECKING PRICE IN DRAFT
					DECLARE @CHECK_DRAFT_PRICE VARCHAR(10)
					SET @CHECK_DRAFT_PRICE =(SELECT COUNT(ROUTE_CD_CHILD) FROM TB_M_DLV_DRAFT_ROUTE_PRICE 
											 WHERE ROUTE_CD_PARENT = @ROUTE_CD AND VALID_TO = '9999-12-31');
											 
					PRINT 'INI CHECK : ' + @CHECK_DRAFT_PRICE --HAPUS
					
					IF(@CHECK_DRAFT_PRICE = 0) BEGIN --IF THIS ROUTE NOT HAVE DRAFT
							PRINT 'INI TERNYATA CHILD' --HAPUS
								--INSERT TABLE HISTORY
								INSERT INTO TB_H_ROUTE_PRICE ([ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],[OPERATION],[OPERATION_BY],[OPERATION_DT])
								(SELECT [ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],'Delete',@CHANGED_BY,GETDATE() 
								FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_FROM = @VALID_FROM_CR)
								
								--UPDATE LAST PRICE
								DECLARE @PRICE NUMERIC(15,2)
								SET @PRICE = (SELECT PRICE FROM TB_M_ROUTE_PRICE 
											  WHERE ROUTE_CD = (SELECT ROUTE_CD_PARENT FROM TB_M_DLV_DRAFT_ROUTE_PRICE WHERE ROUTE_CD_CHILD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_TO = '9999-12-31') 
											  AND VALID_TO = '9999-12-31');
											  
								PRINT @PRICE --HAPUS
								
								UPDATE TB_M_ROUTE_PRICE
								SET VALID_TO = '9999-12-31',PRICE = @PRICE,
								CHANGED_BY = @CHANGED_BY,
								CHANGED_DT = GETDATE()
								WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND
								VALID_TO = (SELECT DATEADD (DAY, -1, @VALID_FROM_CR) FROM TB_M_ROUTE_PRICE 
								WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_TO = '9999-12-31')

								DELETE TB_M_ROUTE_PRICE
								WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_FROM = @VALID_FROM_CR
								
								--CHECK ROUTE PRICE PARENT
								DECLARE @CHECK_PRICE_DRAFT INT
								SET @CHECK_PRICE_DRAFT =(SELECT COUNT(ROUTE_CD) FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD);
								IF(@CHECK_PRICE_DRAFT = 0) BEGIN
									
									--DELETE DRAFT ROUTE PRICE
									DECLARE @CHECK_OLDER INT
									SET @CHECK_OLDER=(SELECT COUNT(*) FROM TB_M_DLV_DRAFT_ROUTE_PRICE WHERE ROUTE_CD_CHILD = @ROUTE_CD AND LP_CD = @LP_CD);
									IF (@CHECK_OLDER > 0) BEGIN
									PRINT 'DELETE DRAFT';
									
										--SELECT
										--UPDATE TB_M_DLV_DRAFT_ROUTE_PRICE SET VALID_TO = '9999-12-31' 
										--WHERE ROUTE_CD_CHILD = @ROUTE_CD AND VALID_FROM <> @VALID_FROM_CR
										
										--DELETE TB_M_DLV_DRAFT_ROUTE_PRICE WHERE ROUTE_CD_CHILD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_FROM ='9999-12-31'
									END
									ELSE BEGIN
									PRINT 'NOTHING'
									--DELETE TB_M_DLV_DRAFT_ROUTE_PRICE WHERE ROUTE_CD_CHILD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_FROM ='9999-12-31'
									END
									
									
									--DELETE
								END
								ELSE BEGIN
								PRINT 'NOTHING'
								END
								
								
					END
					ELSE BEGIN --IF THIS ROUTE HAVE DRAFT
					PRINT 'INI TERNYATA PARENT'
								--INSERT TABLE HISTORY
								INSERT INTO TB_H_ROUTE_PRICE ([ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],[OPERATION],[OPERATION_BY],[OPERATION_DT])
								(SELECT [ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],'Delete',@CHANGED_BY,GETDATE() 
								FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_FROM = @VALID_FROM_CR)
								
								UPDATE TB_M_ROUTE_PRICE
								SET VALID_TO = '9999-12-31',
								CHANGED_BY = @CHANGED_BY,
								CHANGED_DT = GETDATE()
								WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND
								VALID_TO = (SELECT DATEADD (DAY, -1, @VALID_FROM_CR) FROM TB_M_ROUTE_PRICE 
								WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_TO = '9999-12-31')

												
								DELETE TB_M_ROUTE_PRICE
								WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_FROM = @VALID_FROM_CR
								
								--CHECK ROUTE AVAILABLE OR NULL
								DECLARE @CHECK_PRICE_AVAILABLE INT
								SET @CHECK_PRICE_AVAILABLE =(SELECT COUNT(ROUTE_CD) FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD);
								IF(@CHECK_PRICE_AVAILABLE = 0) BEGIN
								
								--DELETE MASTER PRICE
								DELETE FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD IN(SELECT ROUTE_CD_CHILD FROM TB_M_DLV_DRAFT_ROUTE_PRICE WHERE ROUTE_CD_PARENT = @ROUTE_CD)
								END
								ELSE BEGIN
								
								            --HARGA CHILD HARUS SESUAI DENGAN PARENT PRICE, CHECK DENGAN MENGGUNAKAN CURSOR
											DECLARE @ROUTE_CD_CHILD VARCHAR(50),@CHILD_LP_CD VARCHAR(50),@VALID_FROM_CHILD VARCHAR(50);
											DECLARE C_DRAFT_ROUTE CURSOR FOR
											SELECT ROUTE_CD_CHILD,LP_CD,VALID_FROM FROM TB_M_DLV_DRAFT_ROUTE_PRICE WHERE ROUTE_CD_PARENT = @ROUTE_CD AND VALID_TO = '9999-12-31'
											OPEN C_DRAFT_ROUTE
											
											FETCH NEXT FROM C_DRAFT_ROUTE INTO @ROUTE_CD_CHILD,@CHILD_LP_CD,@VALID_FROM_CHILD
											WHILE @@FETCH_STATUS = 0
											BEGIN
											
													--INSERT HISTORY
													INSERT INTO TB_H_ROUTE_PRICE ([ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],[OPERATION],[OPERATION_BY],[OPERATION_DT])
													(SELECT [ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],'Edit',@CHANGED_BY,GETDATE() 
													FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD_CHILD AND LP_CD = @CHILD_LP_CD AND VALID_TO = '9999-12-31')
													
													--UPDATE PRICE
													UPDATE TB_M_ROUTE_PRICE SET PRICE = (SELECT PRICE FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_TO = '9999-12-31'),
													CHANGED_BY = @CHANGED_BY, CHANGED_DT = GETDATE()
													WHERE ROUTE_CD = @ROUTE_CD_CHILD AND LP_CD = @CHILD_LP_CD AND VALID_TO = '9999-12-31'
												
													
													
													
											FETCH NEXT FROM C_DRAFT_ROUTE INTO @ROUTE_CD_CHILD,@CHILD_LP_CD,@VALID_FROM_CHILD
											END
											CLOSE C_DRAFT_ROUTE
											DEALLOCATE C_DRAFT_ROUTE
								
								END
								
								
					END
				
				FETCH NEXT FROM C_ROUTE INTO @ROUTE_CD,@LP_CD,@VALID_FROM_CR,@VALID_TO_CR
				END
				CLOSE C_ROUTE
				DEALLOCATE C_ROUTE
					
				
				--END LOOPING
		
		SELECT 1 --BERHASIL
		PRINT 'DATA SUCCES SAVE';
		END
		ELSE BEGIN
		SELECT 2 --GAGAL
		PRINT 'DATA NOT MATCH';
		END		

END
	ELSE BEGIN
	SELECT 3
END

END

